 /*HEADER------------------------------------------------------------------------
|
| PROGRAM:  calculate_sscp (macro)
||
| PURPOSE:  The main macro create special SAS dataset of the type SSCP (Some of Squares and Cross Products) 


	First version:  04/07/2016, Yury Vilk 	
+------------------------------------------------------------------------HEADER*/
 %MACRO calculate_sscp(tbl_name_in=
										  , independent_vars=
										  ,dependent_vars=
										  ,by_vars=
										  ,freq=, weight=
										  ,tbl_name_out=SSCP_TABLE);

  %IF  %LENGTH(&freq.) >0  %THEN 	 %LET  freq=FREQ &freq.;
  %IF  %LENGTH(&weight.) >0  %THEN 	 %LET  weight=WEIGHT &weight.;
  %IF  %LENGTH(&by_vars.) >0  %THEN 	 %LET  by_vars=BY  &by_vars.;

  PROC CORR DATA=&tbl_name_in. OUTP=&tbl_name_out.(TYPE=SSCP) 
									SSCP NOCORR  NOMISS NOPRINT ;
	&by_vars.;
   VAR &independent_vars. &dependent_vars.;
     &freq.;
   	 &weight.;	 
RUN;

%MEND;

/*		Usage example

%LET reg_ds_in=DATA_IN.LINEAR_KARR_2005;
 %LET  dependent_vars=medv;
*%LET independent_vars=crim indus dis;
%LET independent_vars=crim indus dis dummy_dp_var2 -  dummy_dp_var&count_dp.;
 *%LET  weight=%STR();
 *%LET  freq=%STR();
  %LET  weight=WEIGHT1;
 %LET  freq=FREQ1;
  %LET prefix=tc1_;

%calculate_sscp(tbl_name_in=&reg_ds_in.
                             ,independent_vars=&independent_vars.
							 ,dependent_vars=&dependent_vars.
							 ,freq=&freq. 
                             ,weight=&weight.
							 ,tbl_name_out=&prefix.SSCP);
*/