/*  
 First version:  02/04/2016, Yury Vilk.  
     Modified:  06/05/2017	  Yury Vilk
  Usage: 

	  %LET iter_nb=2;
      %LET prefix0=dr3_;
	  %LET prefix=&prefix0.i&iter_nb._;
	  %LET prefix_prev=&prefix0.i%eval(&iter_nb.-1)_  ;
	  %LET xconv=1e-2;

%LET tbl_p_est_in=dplocal.&prefix.P_Est;
%LET tbl_prev_p_est_in=dplocal.&prefix_prev.P_Est;
 %LET tbl_p_est_tr_in=dplocal.&prefix.Model_Coeff;
 %LET tbl_convrg_status_out=&prefix.Convrg_Status;
 %LET tbl_Iter_parms_hist_updt=dplocal.&prefix0.Iter_Parms_hist;

	%check_track_convergence(tbl_p_est_in=dplocal.&prefix.P_Est
					                             ,tbl_prev_p_est_in=dplocal.&prefix_prev.P_Est
					                             ,tbl_p_est_tr_in=dplocal.&prefix.Model_Coeff
					                             ,tbl_convrg_status_out=&prefix.Convrg_Status
					                             ,tbl_Iter_parms_hist_updt=dplocal.&prefix0.Iter_Parms_hist
                                                  );

  */

%MACRO check_track_convergence(tbl_p_est_in=
															 ,tbl_prev_p_est_in=
															 ,tbl_p_est_tr_in=
															 ,tbl_convrg_status_out=
															 ,tbl_Iter_parms_hist_updt=
                                                            );
	%PUT;
   %PUT -----   Start of the macro check_track_convergence;
   %PUT;


		PROC SQL;
		    CREATE TABLE &tbl_convrg_status_out.	 AS
				 SELECT MAX(&iter_nb) AS iter_nb
								,MAX(CASE
								   WHEN ABS(P.Estimate) <0.01 THEN ABS(C.Estimate-P.Estimate) 
								    ELSE ABS((C.Estimate-P.Estimate)/P.Estimate)
								END) AS max_abs_Estimate_Chg
								,MIN(CASE
								   WHEN ABS(P.Estimate) <0.01 THEN ABS(C.Estimate-P.Estimate) <	&xconv.
								    ELSE ABS((C.Estimate-P.Estimate)/P.Estimate)	<	&xconv.
								END) AS reg_conv_in

				   FROM 			&tbl_p_est_in. 			AS C
					INNER JOIN 	 &tbl_prev_p_est_in. AS P
					 ON C.Variable=P.Variable
					  ;
				QUIT;

 	         DATA &prefix.Iter_Parms;
				LENGTH 	iter_nb 8 LogLikelihood Neg2LogLike 8;
				 SET &tbl_p_est_tr_in.(KEEP=&Intercept. &independent_vars.);
				    IF _N_=1 THEN SET &prefix.Convrg_Status;
					CALL SYMPUT("reg_conv_in", PUT(reg_conv_in,1.0));
					IF reg_conv_in=1 THEN 
	                              DO;
			   CALL SYMPUT("iter_nb_at_conv", STRIP(PUT(iter_nb,4.0)) );
			   PUT "iter_nb_at_conv=" iter_nb;
								  END;
					LogLikelihood=.;
                    Neg2LogLike=.;
			RUN;

			
	DATA  &prefix.Neg2LogLike;
		SET DPLocal.&prefix.resid_sum(KEEP=_LL__Sum _L__Sum);
		 	iter_nb=&iter_nb.-1;
		    LogLikelihood=_L__Sum ;
			Neg2LogLike=-2*_L__Sum;
			DROP _L__Sum ;
	RUN;

	   	DATA  &tbl_Iter_parms_hist_updt.;
		LENGTH	iter_nb 8 LogLikelihood Neg2LogLike 8;
			MERGE   &tbl_Iter_parms_hist_updt.
							&prefix.Iter_Parms	
                            &prefix.Neg2LogLike
							;
			BY iter_nb;
		 RUN;

  %PUT;
   %PUT -----   End of the macro check_track_convergence ;
   %PUT;

%MEND;