
      %MACRO cox_reg_with_data_input(tbl_name_in= 
															   ,dependent_vars=
															   ,independent_vars=
															   ,censoring_var=
															   ,censoring_lev=0
															   ,strata_vars=
															   ,ties=BRESLOW
															   ,freq=
															   ,weight=
                                                               ,tbl_intial_est=
															   ,prefix=cc1_
															   ,alpha=0.05
															   ,lib_out=DPLocal
															  ,groups=10
															  ,xconv=1e-4
															  ,max_iter_nb=10
																) ;

   %LOCAL freq_c freq2 weight_c stata_vars_c strata_vars_csv  ties_sh baseline_est 
                  tbl_intial_est_c weight2 lib_out0 str_Select   _cl ;

  
  /*
      Usage:


%LET tbl_name_in=DATA_IN.RECID_DR;
 *  %LET tbl_name_in=DATA_IN.RECID_DR_C_5;
%LET dependent_vars=week;
%LET independent_vars=fin age  prio;
* %LET independent_vars=fin age race wexp mar paro prio;
%LET censoring_var=arrest;
%LET censoring_lev=0;
%LET strata_vars=;
  * %LET strata_vars=dp_cd;
  *  %LET strata_vars=strata_var2;
  * %LET strata_vars=dp_cd  strata_var2;
  *  %LET strata_vars=strata_var2 dp_cd;
  * %LET ties=BRESLOW;
   *%LET baseline_est= BRESLOW ;
    %LET ties=EFRON;
   	%LET baseline_est= FH ;
* %LET tbl_intial_est=infolder.Cox_Model_Coeff_3   ;
 %LET tbl_intial_est=;
 %LET xconv=1e-4;
%LET lib_out=DPLocal;
%LET alpha=0.05;
%LET max_iter_nb=10;
   %LET groups=10;

   %LET prefix_c=ccse1_;
	%LET freq=;
	%LET weight=;

					  %cox_reg_with_data_input(tbl_name_in=&tbl_name_in. 
															   ,dependent_vars=&dependent_vars.
															   ,independent_vars=&independent_vars.
															   ,censoring_var=&censoring_var.
															   ,censoring_lev=&censoring_lev.
															   ,freq=
															   ,weight=
                                                               ,tbl_intial_est=&tbl_intial_est.
															   ,prefix=&prefix_c.
															   ,alpha=&alpha.
															   ,lib_out=&lib_out.
															  ,groups=10
															  ,xconv=&xconv.
															  ,max_iter_nb=&max_iter_nb.
																) ;
	  */

   	 %LET lib_out0=&lib_out.;

    %LET  weight_c=;	
    %LET  freq_c=;
	%LET tbl_intial_est_c=;

	 %LET  freq2=1;
	 %LET  weight2=1;
  /*
   * %LET strata_vars=dp_cd;
  *  %LET strata_vars=strata_var2;
  * %LET strata_vars= dp_cd strata_var2 ;
 *	 %LET strata_vars=strata_var2  dp_cd ;
*/
	%LET  class_strata_vars=;
	%LET by_strata_vars=;
     %LET strata_vars_c=;
	 %LET strata_vars_csv=;
	 %LET strata_vars_no_dp_cd=;
	 %LET strata_vars_with_dp_cd=&strata_vars.;
	 %LET strata_vars_no_dp_cd_csv=;
	 %LET last_strata_var=;

	 %LET ties=%LOWCASE(&ties.);
	 %LET ties_sh=%SUBSTR(&ties.,1,1);
	 %LET baseline_est= ;

	 %LET pos_dp_cd_in_strata_vars=0;

%MACRO wrapper;
  	 
	 %IF  %LENGTH(&lib_out.) >0  AND  %INDEX(&lib_out.,.) =0 %THEN 	 %LET  lib_out=&lib_out..;

	 %IF  %LENGTH(&tbl_intial_est.) >0 %THEN 	 %LET tbl_intial_est_c=%STR(INEST=&tbl_intial_est.);

	
 %IF  %LENGTH(&freq.) >0  		%THEN 
                            %DO; 
      %LET  freq2=&freq.;	
      %LET  freq_c=FREQ &freq. ;
                            %END;
 %ELSE 		%LET  freq2=1;

  %IF  %LENGTH(&weight.) >0  %THEN 	  
                                 %DO; 
               %LET     weight2=&weight.; 
               %LET    weight_c=WEIGHT &weight.;
                               %END;
	%ELSE 	%LET  weight2=1;

    %IF  %LENGTH(&strata_vars.) >0  %THEN 	  
                           %DO;
	  %LET strata_vars= %SYSFUNC(COMPBL(&strata_vars.));
	   %LET  by_strata_vars=BY &strata_vars.;
       %LET  class_strata_vars=CLASS &strata_vars.; 
      %LET pos_dp_cd_in_strata_vars=%SYSFUNC(INDEXW(&strata_vars., dp_cd));
 	 
	  %LET last_strata_var=%SYSFUNC(SCAN(&strata_vars., -1));;

	  %IF &pos_dp_cd_in_strata_vars. =0 %THEN %LET strata_vars_with_dp_cd=dp_cd &strata_vars.;
	 %LET strata_vars_no_dp_cd=%SYSFUNC(TRANWRD(&strata_vars.,dp_cd,%STR()) );


               %LET  strata_vars_c=STRATA &strata_vars.; 
			   %LET  strata_vars_csv=%SYSFUNC(TRANSLATE(&strata_vars.,%STR(,), %STR( ) )) ,; 

           %IF %LENGTH(&strata_vars_no_dp_cd.) >0 
		   %THEN   
												  %DO;
		  %LET strata_vars_no_dp_cd=%SYSFUNC(COMPBL(&strata_vars_no_dp_cd.));
          %LET	strata_vars_no_dp_cd_csv=%SYSFUNC(TRANSLATE(&strata_vars_no_dp_cd.,%STR(,), %STR( ) )) ,; 
											      %END;
                       %END;

		  %IF &ties_sh.=b %THEN  %LET  baseline_est=BRESLOW;
		  %ELSE 							 %LET  baseline_est=FH;

 %MEND;

 %wrapper;

 %PUT lib_out=&lib_out;
  %PUT strata_vars=&strata_vars.;
  %PUT by_strata_vars=&by_strata_vars.;
 %PUT class_strata_vars=&class_strata_vars.; 
 %PUT 	strata_vars_c=&strata_vars_c.;
*  %PUT 	strata_vars_csv=&strata_vars_csv.;
  %PUT last_strata_var=&last_strata_var.;
  %PUT pos_dp_cd_in_strata_vars=&pos_dp_cd_in_strata_vars.;
 * %PUT strata_vars_with_dp_cd=&strata_vars_with_dp_cd.;
* %PUT strata_vars_no_dp_cd=&strata_vars_no_dp_cd.;
 * %PUT strata_vars_no_dp_cd_csv=&strata_vars_no_dp_cd_csv.;
  %PUT ties=&ties;
  %PUT ties_sh=&ties_sh.;
  %PUT baseline_est=&baseline_est.;
   
 * ODS SELECT NONE;

 * ODS GRAPHICS ON;
  ODS TRACE ON;
  
ODS OUTPUT NObs=&lib_out.&prefix_c.NObs;
ODS OUTPUT ModelInfo=&lib_out.&prefix_c.ModelInfo;
ODS OUTPUT CensoredSummary=&prefix_c.Cens_Sum_char;
*ODS OUTPUT SimpleStatistics=&lib_out.&prefix_c.Simple_Stats;
ODS OUTPUT ParameterEstimates=&lib_out.&prefix_c.P_Est(RENAME=(Parameter=Variable));
ODS OUTPUT CovB=&lib_out.&prefix_c.Cov_Est(RENAME=(Parameter=Variable));
ODS OUTPUT IterHistory=&lib_out.&prefix_c.Iter_Parms_hist;
ODS OUTPUT ConvergenceStatus=&lib_out.&prefix_c.Convrg_Status;
ODS OUTPUT LastGradient=&lib_out.&prefix_c.Last_Gradient;	
ODS OUTPUT FitStatistics=&lib_out.&prefix_c.ModelFit;	
ODS OUTPUT GlobalTests=&lib_out.&prefix_c.Glob_Null_ChiSq; * Comp with \beta=0  model. Small p-value: good model;
* ODS OUTPUT RiskSetInfo =&lib_out.&prefix_c.Risk_Set_Info ;
*ODS OUTPUT ReferenceSet=&lib_out.&prefix_c.ReferenceSet;

*ODS EXCLUDE NObs ;

PROC PHREG DATA=&tbl_name_in.
									ALPHA=&alpha.
								  /*	COVSANDWICH	 Requests the robust sandwich estimate for the covariance matrix. Otherwise model based is used */
									COVM   /*Works only with COVSANDWICH Requests that the model-based covariance matrix 
									                  was outputed in addition for Sanandwich estimates */
								     &tbl_intial_est_c.  	/*Similar structure as OUTEST but only _TYPE_PARMS are needed */ 
									OUTEST=&lib_out.&prefix_c.MODEL_COEFF_L
								/*	PLOTS(OVERLAY)=(SURVIVAL CUMHAZ ) */
								    PLOTS=NONE
      ;
       &freq_c.	 ;
	  &weight_c.;

  MODEL &dependent_vars.*&censoring_var.(&censoring_lev.)=&independent_vars./ TIES=&TIES.  /* BRESLOW EFRON  DISCRETE EXACT */ 
															   COVB
  															   ITPRINT 
															XCONV=&xconv.  /* Parameters estimates criteria */
														    MAXITER=&max_iter_nb. 													
      					;
	 &strata_vars_c.;
	 BASELINE OUT=&prefix_c.Cox_Baseline_Strata  
                                  XBETA=_XBETA_ 
                                SURVIVAL=_SURVIVAL_at_MEAN_strata 
                                  LOGSURV=_LOGSURV_at_MEAN_strata
                 ; 
	OUTPUT OUT=&prefix_c.Cox_Residuals
	 							 ATRISK=N_subj_at_risk
								 RESMART=Resid_Martingale /* Difference over [0,week] in the observed number of events 
								                                                     minus the expected number of events  */
								 RESDEV=Resid_Dev /* Transform of the martingale residual to achieve a more symmetric distribution.*/
								 RESSCO=Resid_Score_fin Resid_Score_age /*Component of the first partial derivative of the log likelihood */
                                 RESSCH=sch_fin sch_age sch_prio /* Schoenfeld residuals. Helpful in assessing
								 															 the proportional hazards assumption*/
							      XBETA=_XBETA_
								  STDXBETA=_STDXBETA_
								  SURVIVAL=_SURVIVAL_
								  LOGSURV=_LOGSURV_
								/METHOD=&baseline_est.	 /*BRESLOW FH  PL*/  /* Method the survivor function estimates*/
							 
         				;
RUN;
QUIT;

  ODS SELECT ALL;
  ODS GRAPHICS OFF;
  ODS TRACE OFF;



 DATA &lib_out.&prefix_c.P_Est;
   SET &lib_out.&prefix_c.P_Est;
 	    alpha=&alpha.;
		Quantile=PROBIT((1- alpha/2));
	    LowerCL=Estimate-Quantile*StdErr;
		UpperCL=Estimate+Quantile*StdErr;
		HR_LowerCL=EXP(LowerCL);
		HR_UpperCL=EXP(UpperCL);
  RUN;

  	DATA  _NULL_;
		   CALL SYMPUT("_cl",STRIP(PUT(100*(1.0-&alpha.),best12.)));
	RUN;
			 
			   %PUT _cl=&_cl.;

  PROC DATASETS LIB=&lib_out0. NOLIST;
			 MODIFY &prefix_c.P_Est;
				 LABEL 
				 Variable="Parameter"
				  Estimate="Parameter Estimate"                                   
                  StdErr="Standard Error"                                         
                  ChiSq="Chi-Square"
                  ProbChiSq="Pr > Chi-Square"                                           
                  LowerCL="Lower &_cl.% CL Parameter"                                
                  UpperCL="Upper &_cl.% CL Parameter" 
                  HazardRatio="Hazard Ratio"
                  HR_LowerCL="Lower &_cl.% CL Hazard Ratio"	
				  HR_UpperCL="Upper &_cl.% CL Hazard Ratio"		
			 ;
		  RUN;

/*		  
  PROC DATASETS  NOWARN NOLIST;
   DELETE __Cov_Est;
 RUN;
 QUIT;

  DATA __Cov_Est;
 * LENGTH Covtype $ 16;
    SET &lib_out.&prefix_c.Cov_Est;
	
*	IF 	STRIP(UPCASE(Covtype)) NE "SANDWICH";
	KEEP &independent_vars.	;
  RUN;

 %calc_matrix_ginv_iml(tbl_name_in=__Cov_Est,tbl_name_out=&lib_out.&prefix_c.Hessian);  */


DATA &lib_out.&prefix_c.Cox_Baseline_Strata;
 SET &prefix_c.Cox_Baseline_Strata;

 	IF 	&dependent_vars. NE . AND _XBETA_ NE .;

 * As expected gives the same value for the same times and regardless of _XBETA_;
   _Cum_Hazard0_= - _LOGSURV_at_MEAN_strata /EXP(_XBETA_);
   _LOGSURV0_=-  _Cum_Hazard0_;
RUN;

									   
PROC SORT DATA=&prefix_c.Cox_Residuals;
  BY &strata_vars. &dependent_vars. DESCENDING &censoring_var.;	
RUN;

DATA &lib_out.&prefix_c.Cox_Residuals;
 SET &prefix_c.Cox_Residuals;

 	IF 	&dependent_vars. NE . AND _XBETA_ NE . AND &censoring_var. NE .;

	   _FREQ_=&freq2.;
	   _WEIGHT_=&weight2.;

 	_CENSORING_VAR_=(&censoring_var. NE &censoring_lev.);

 * As expected gives the same value for the same times and regardless of _XBETA_;
   _Cum_Hazard0_= - _LOGSURV_/EXP(_XBETA_);
   _LOGSURV0_=-  _Cum_Hazard0_;
RUN;

	%sum_by_pct2(tbl_name_in=&lib_out.&prefix_c.Cox_Residuals
			                    ,tbl_name_out= &lib_out.&prefix_c.resid_sum_by_pct
								,by_var=dp_cd
								,freq=_FREQ_
			                    ,x_var= _XBETA_
                                ,y_var=Resid_Martingale Resid_Dev
								,stats_for_y_vars=%STR(MEAN=  )
                                ,groups=&groups.);


    /*The MAX function below does not much since baseline hazard is unique
         per &dependent_vars. However, it is requiered because of possible rounding errors/final precision */
		
 PROC MEANS DATA=&lib_out.&prefix_c.Cox_Residuals NWAY NOPRINT;
  CLASS &strata_vars. &dependent_vars.;
	VARS  _Cum_Hazard0_;
		 WHERE  &censoring_var. NE  &censoring_lev. ;
	    OUTPUT 	 OUT=&prefix_c.baseln_hazard(DROP=_TYPE_ _FREQ_ )
						   MAX=;
	  RUN;
	QUIT;


PROC MEANS DATA=&lib_out.&prefix_c.Cox_Residuals NWAY NOPRINT;
  &class_strata_vars.;
  WHERE  &censoring_var. NE  &censoring_lev. ;
	VARS  _XBETA_;
	    OUTPUT 	 OUT=&prefix_c._XBETA_MEAN(DROP=_TYPE_ _FREQ_ )
						   N(_XBETA_)=Count MEAN(_XBETA_)=_XBETA__MEAN;
	  RUN;
	QUIT;

	
	PROC MEANS DATA=&lib_out.&prefix_c.Cox_Residuals NWAY NOPRINT;
	&class_strata_vars.;
		 FREQ _FREQ_;
			 VAR  _CENSORING_VAR_  _WEIGHT_;
	       OUTPUT 	 OUT=&prefix_c.cens_sum_s(DROP=_TYPE_ RENAME=(_FREQ_=Total))
                            SUM(_CENSORING_VAR_)=Event
							SUM(_WEIGHT_)=_SUMWGT_
                               ;
	    RUN;
      QUIT;

	  	PROC MEANS DATA=&prefix_c.cens_sum_s NWAY  NOPRINT;
			 VAR Total Event  _SUMWGT_;
	       OUTPUT 	 OUT=&prefix_c.cens_sum( DROP=_TYPE_ _FREQ_ )
        					SUM=;
	    RUN;
 	  QUIT;

	    DATA  &prefix_c.cens_sum_s
		           dplocal.&prefix_c.Stratum_map(KEEP=Stratum &strata_vars.)
                      ;
		 LENGTH Stratum 8;
		  SET &prefix_c.cens_sum_s ;
		  Stratum=_N_;
		  RUN;
	
   %MACRO wrapper;
    %IF %LENGTH(&strata_vars.) >0 %THEN
	                     %DO;
	   DATA  &prefix_c.cens_sum;
		  SET &prefix_c.cens_sum_s  &prefix_c.cens_sum(IN=in_t);
		    IF in_t THEN Stratum=.;
		  RUN;
	
   DATA &lib_out.&prefix_c.baseln_hazard;
     LENGTH Stratum 8;
       MERGE  &prefix_c.baseln_hazard(IN=in_haz)
	  			   dplocal.&prefix_c.Stratum_map;
	 	 BY &strata_vars.;
		 IF in_haz;
	 RUN;

	  DATA &lib_out.&prefix_c.mean_vars_by_st;;
     LENGTH Stratum 8;
       MERGE  &prefix_c._XBETA_MEAN(IN=in_mean)
	  			   dplocal.&prefix_c.Stratum_map;
	 	 BY &strata_vars.;
		 IF in_mean;
	 RUN;

						%END;
	 %ELSE
	                   %DO;

  DATA &lib_out.&prefix_c.baseln_hazard;
     LENGTH Stratum 8;
       SET &prefix_c.baseln_hazard;
		 Stratum=1;
	 RUN;

	DATA &lib_out.&prefix_c.mean_vars_by_st;
	  LENGTH Stratum 8;
	  SET &prefix_c._XBETA_MEAN;
	    	Stratum=1;
	RUN;
					   %END;
	%MEND;

	%wrapper;

		/* We do not use the ODS table CensoredSummary because it 
	         converts numeric strata_vars to character */

	    DATA &lib_out.&prefix_c.cens_sum;
		 LENGTH Stratum 8;
		 SET &prefix_c.cens_sum nobs=_nobs_;

		 IF _nobs_=1 THEN Stratum=1;
		   	 Censored=Total - Event;
			 PctCens=100*Censored/Total;
			 FORMAT PctCens 8.2;
		   KEEP Stratum &strata_vars. Total Event Censored PctCens _SUMWGT_;
	   RUN;

	 DATA 	&lib_out.&prefix_c.baseln_survival ;
		 MERGE &lib_out.&prefix_c.baseln_hazard  
                  &lib_out.&prefix_c.mean_vars_by_st;
			BY  Stratum;

		 _SURVIVAL_at_MEAN=EXP(-  _Cum_Hazard0_ * EXP(_XBETA__MEAN) );
		RUN;

 %MEND; 