
   %MACRO lin_reg_with_sscp_input(tbl_name_in= 
															   ,dependent_vars=
															   ,independent_vars=
															   ,NOINT=
															  ,model_label=_XBETA_
															   ,prefix=r1_
															   ,alpha=0.05
															   ,lib_out=DPLocal
																) ;

	 %IF  %LENGTH(&lib_out.) >0  AND  %INDEX(&lib_out.,.) =0 %THEN 	 %LET  lib_out=&lib_out.%STR(.);

 ODS SELECT NONE;
	
	 	  ods output ANOVA=&lib_out.&prefix.ANOVA;
	     ods output ParameterEstimates=&lib_out.&prefix.P_Est;
         ods output Covb=&lib_out.&prefix.Cov_Est;
		 ods output InvXPX =&lib_out.&prefix.InvXPX ;   /* This is is inverse of Inv(X'X) bordered by parm estimates*/;
		 ods output  FitStatistics=&lib_out.&prefix.FitStatistics ;
		 ods output CollinDiag=&lib_out.&prefix.CollinDiag;

    PROC REG DATA=&tbl_name_in.
						 OUTEST=&lib_out.&prefix.Model_Coeff	 
							;
		&model_label.:	MODEL	 &dependent_vars.=&independent_vars. / CLB COVB 
																															COLLIN   
																														     ADJRSQ AIC BIC SBC
																															 RMSE 
																														     EDF
																															   I
																                                                            ALPHA=&alpha.
																															&NOINT. 
						;
	RUN;
	QUIT;
		   ODS SELECT ALL;   
	%MEND;

   /*
	      %lin_reg_with_sscp_input(tbl_name_in=DPLocal.&prefix.SSCP 
													   ,dependent_vars=&dependent_vars.
													   ,independent_vars=&independent_vars.
													   ,NOINT=&NOINT.
													   ,model_label=_XBETA_
													   ,prefix=&prefix.
													   ,lib_out=DPLocal
														) ;
	*/